﻿Public Class CalcYeardata
    Public WithEvents _filePathsConfig As New FilePathsConfig
    ' Event, das bei einem XML-Datei Fehler ausgelöst wird
    Public Event YearDataCalculated(ByVal yearData As List(Of Double))

    ''' <summary>
    ''' 'Berechnungen stimmen nicht
    ''' </summary>
    ''' <param name="ypath"></param>

    Public Sub CalculateYearlyAverages(ypath As String)
        Dim yearlyTotals As New List(Of Double)()
        Debug.WriteLine("ClassCalc " & _filePathsConfig.filePath, ypath)
        ' Lese die XML-Dateien aus dem Verzeichnis
        Dim directoryPath As String = _filePathsConfig.filePath & ypath
        Dim xmlFiles As String() = Directory.GetFiles(directoryPath, "*.xml")
        For Each xmlFile As String In xmlFiles
            ' Extrahiere das Jahr aus dem Dateinamen
            Dim fileName As String = Path.GetFileNameWithoutExtension(xmlFile)
            Dim year As Integer = Convert.ToInt32(fileName.Substring(3, 4))
            ' Lese die XML-Datei ein
            Dim xmlDoc As XDocument = XDocument.Load(xmlFile)
            ' Berechne die monatlichen Gesamtsummen
            Dim monthlyTotals As New List(Of Double)()
            For Each weatherDataElement As XElement In xmlDoc.Descendants("WeatherData")
                Dim regenTag As Double = CDbl(weatherDataElement.Element("RegenTag").Value)
                Dim schneeTag As Double = CDbl(weatherDataElement.Element("SchneeTag").Value)
                Dim schneeNacht As Double = CDbl(weatherDataElement.Element("SchneeNacht").Value)
                Dim luftfminTag As Double = CDbl(weatherDataElement.Element("LuftfminTag").Value)
                Dim luftfmaxTag As Double = CDbl(weatherDataElement.Element("LuftfmaxTag").Value)
                Dim luftfminNacht As Double = CDbl(weatherDataElement.Element("LuftfminNacht").Value)
                Dim luftfmaxNacht As Double = CDbl(weatherDataElement.Element("LuftfmaxNacht").Value)
                Dim tempTag As Double = CDbl(weatherDataElement.Element("TempTag").Value)
                Dim tempNacht As Double = CDbl(weatherDataElement.Element("TempNacht").Value)
                Dim windTag As Double = CDbl(weatherDataElement.Element("WindTag").Value)
                Dim windNacht As Double = CDbl(weatherDataElement.Element("WindNacht").Value)

                Dim monthlyTotal As Double = regenTag + schneeTag + schneeNacht + luftfminTag + luftfmaxTag + luftfminNacht + luftfmaxNacht + tempTag + tempNacht + windTag + windNacht
                monthlyTotals.Add(monthlyTotal)
            Next
            ' Füge die monatliche Gesamtsumme zur Liste der Jahresdaten hinzu
            yearlyTotals.AddRange(monthlyTotals)
        Next
        ' Überprüfe, ob yearlyTotals mindestens ein Element enthält
        If yearlyTotals.Count > 0 Then
            ' Berechne den Jahresdurchschnitt
            Dim yearlyAverage As Double = yearlyTotals.Average()
            ' Sende die Daten über das Event an das DataGridView
            RaiseEvent YearDataCalculated(yearlyTotals.Select(Function(d) Math.Round(d, 2)).ToList())
            ' Weitere Verarbeitung des Jahresdurchschnitts...
        Else
            ' Handle den Fall, wenn yearlyTotals leer ist

        End If
    End Sub

End Class